@echo off

REM ------ vars.txt ------------------------------
if not exist vars.txt (
	echo Error: 'vars.txt' not found.
	pause
	exit
)
ren vars.txt *.bat
call vars.bat
ren vars.bat *.txt
cls
prompt $N:$G
REM ----------------------------------------------
SET MYSQLCMD="%mysqlPath%" --default-character-set=utf8 -h %gshost% -u %gsuser% --password=%gspass% -D %gsdb%
@REM ----------------------------------------------
@ECHO ON

%MYSQLCMD% < ..\my_addon\gm_shop\gm_shop.SQL
%MYSQLCMD% < ..\my_addon\gm_shop\gm_shop_plus.SQL
%MYSQLCMD% < ..\my_addon\pets_stats_pig.sql
%MYSQLCMD% < ..\sql\npc_buffer_list.sql

@REM ----------------------------------------------

PUSHD ..
CALL event_MissQueen_SETUP.bat
CALL event_Valentines_SETUP.bat
CALL event_Christmas_SETUP.bat
CALL event_Pumpkin_SETUP.bat

POPD

@ECHO OFF

:end
echo.
echo Script complete.
pause
