﻿## Active Perl 5.8.8

use utf8;
use warnings;
use strict;
use Encode;
binmode STDOUT, ':encoding(cp932)'; $|=1;

my $DEBUG = 0;

&start('./');

exit 0;

sub start {
	my ($subDir) = @_;

	opendir DIR,$subDir  or die $!;
	my @files = readdir DIR;
	closedir DIR;

	foreach my $fileName (@files) {
		next if $fileName =~ m/^\./;
		next if $fileName =~ m/ /;

		my $filePath = $subDir.$fileName;
		if (-d $filePath) {
			&start($filePath.'/');

		} elsif ($fileName =~ m!\.htm$!) {
			open FILE, '<:utf8', $filePath  or die "'$filePath' $!";
			read FILE, my $htm, -s FILE;
			my $mtime = (stat FILE)[9];
			close FILE;

			my $original = $htm;
			$_           = $htm;
#----------------------------------------------------------------------------
s!(<button value="Main"[^>]+)width=40 height=15!$1WIDTH=60 HEIGHT=18!gs;
s!(<button value="Back"[^>]+)width=40 height=15!$1WIDTH=50 HEIGHT=18!gs;

s!<table width=240>!<TABLE WIDTH=255 BORDER=0 CELLSPACING=0 CELLPADDING=0>!gs;
s!(<button[^>]+)width=55 height=15!$1WIDTH=60 HEIGHT=18!gs;
s!(<button[^>]+)height=15!$1HEIGHT=18!gs;
#----------------------------------------------------------------------------
			$htm = $_;

			if ($htm ne $original) {
				print $filePath,"\n";
				my $output = $filePath;
				   $output = $filePath.'.text' if $DEBUG;
				open FILE, '>:utf8', $output  or die "'$output' $!";
#				$htm = "\x{feff}".$htm unless $htm =~ m/^\x{feff}/;  #BOM
				print FILE $htm;
				close FILE;
				utime $mtime,$mtime,$output;
			}
		}
	}
}
